# HostTrait

import slogan, slogan.traits
import string, re, socket
[false, true]= range(2)

ipv4= re.compile('^'+string.join(['\\d+']*4, '\\.')+'$')
ipv6= re.compile('^'+string.join(['[0-9A-Za-z]*']*8, ':')+'$')

# Trait for hostname of the requestor. If a numerical address is found, try to
# resolve it. If that fails, use the address as a subelement of 'numerical IP
# addresses'. Keep a cache of known IP addresses; maybe this could persist in
# the database in the future?

hostCache= {}

class Trait(slogan.traits.Trait):
  identity= 'host'
  extended= 'c-ip'
  priority= 120
  size= [8]+[32]*4
  def __init__(self):
    self.title= slogan.language.host_title

  def read(self, logpart):
    isNumerical= ipv4.match(logpart)!=None or ipv6.match(logpart)!=None
    if isNumerical and slogan.config['resolveIP']:
      if not hostCache.has_key(logpart):
        try:
          hostCache[logpart]= socket.gethostbyaddr(logpart)[0]
        except socket.error:
          hostCache[logpart]= None
      if hostCache[logpart]!=None:
        logpart= hostCache[logpart]
        isNumerical= false
    partlist= string.split(string.lower(logpart), '.')
    if isNumerical:
      partlist= ['.']+map(lambda x: ('0'*(3-len(x)))+x, partlist)
    else:
      partlist.reverse()
    return partlist

  def write(self, partlist):
    if len(partlist)>0:
      if partlist[0]=='.':
        if len(partlist)>1:
          def strip0(x):
            while len(x)>1 and x[:1]=='0':
              x= x[1:]
            return x
          return 'IP '+string.join(map(strip0, partlist[1:])+['x']*(5-len(partlist)), '.')
        else:
          return slogan.language.host_ip
    partlist= partlist[:]
    partlist.reverse()
    return string.join(partlist, '.')

  def icon(self, partlist):
    return ['host']+partlist
