# ReferrerTrait

import slogan, slogan.traits, slogan.traits.host
import string

# Trait for the HTTP Referer [sic] header. Split this into host, page, query.

class Trait(slogan.traits.Trait):
  identity= 'referrer'
  extended= 'cs(Referer)'
  priority= 70
  size= [80]*3
  def __init__(self):
    self.title= slogan.language.referrer_title

  def read(self, logpart):
    methodEnd= string.find(logpart, '://')
    if methodEnd==-1:
      methodEnd= 0
    else:
      methodEnd= methodEnd+3
    partlist= string.split(logpart[methodEnd:], '/', 1)
    partlist[0]= string.lower(partlist[0])
    if len(partlist)>1:
      partlist[1:]= string.split(partlist[1], '?', 1)
    return partlist

  def write(self, partlist):
    if len(partlist)>0 and partlist[0]!='':
      ref= partlist[0]
    else:
      ref= slogan.language.referrer_none
    if len(partlist)>1 and partlist[1]!='':
      ref= ref+'/'+partlist[1]
      if len(partlist)>2 and partlist[2]!='':
        ref= ref+'?'+partlist[2]
    return ref

  def icon(self, partlist):
    if len(partlist)>1:
      return slogan.traitObjects['file'].icon(partlist[1])
    if len(partlist)>0:
      hostlist= string.split(partlist[0], '.')
      hostlist.reverse()
      return slogan.traitObjects['host'].icon(hostlist)
    return ['referrer']
