# TimeTrait

import slogan, slogan.traits
import string

# Trait for time of access.

# Time zone information, if supplied, is ignored for now; it is assumed
# that the user will want to browse the time information in the same locale
# as the server is running. This does mean that DST changes will result in
# a repeated or skipped hour, though. Time zone handling may be
# added later but it will require a user configuration option to specify
# current viewing time zone.

class Trait(slogan.traits.Trait):
  identity= 'time'
  extended= 'time'
  priority= 90
  size= [2, 2, 2]
  def __init__(self):
    self.title= slogan.language.time_title

  def read(self, logpart):
    timeList= string.split(logpart, ' ', 1)
    partlist= string.split(timeList[0], ':', 2)
    while len(partlist)<3:
      partlist.append('00')
    return partlist

  def write(self, partlist):
    if len(partlist)==1:
      return partlist[0]+':00 - '+partlist[0]+':59'
    else:
      return string.join(partlist, ':')
